/****************************************************************************
** $Id:  qt/qapplication.h   3.0.1   edited Nov 1 01:03 $
**
** Definition of QApplication class
**
** Created : 931107
**
** Copyright (C) 1992-2000 Trolltech AS.  All rights reserved.
**
** This file is part of the kernel module of the Qt GUI Toolkit.
**
** This file may be distributed under the terms of the Q Public License
** as defined by Trolltech AS of Norway and appearing in the file
** LICENSE.QPL included in the packaging of this file.
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
** Licensees holding valid Qt Enterprise Edition or Qt Professional Edition
** licenses may use this file in accordance with the Qt Commercial License
** Agreement provided with the Software.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
**   information about Qt Commercial License Agreements.
** See http://www.trolltech.com/qpl/ for QPL licensing information.
** See http://www.trolltech.com/gpl/ for GPL licensing information.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
**********************************************************************/

#ifndef QAPPLICATION_H
#define QAPPLICATION_H


#ifndef QT_H
#include "qdesktopwidget.h"
#include "qasciidict.h"
#include "qpalette.h"
#include "qtranslator.h"
#include "qstrlist.h"
#include "qstringlist.h"
#endif // QT_H

#ifndef QT_NO_REMOTE
#include "quuid.h"
#endif //QT_NO_REMOTE

#include <util/handler.h>


class QApplicationPrivate;
class os::Message;

class QApplication : public QObject, public os::Handler
{
	Q_OBJECT
public:
	QApplication( int argc, char **argv, const char *name );
    virtual ~QApplication();
    void enter_loop();
    void exit_loop();
	static QSize     globalStrut();
	static QWidget*	 focusWidget();
	static int		 startDragDistance();
	static void		 setOverrideCursor( QCursor );
	static void		 restoreOverrideCursor();
	
	static QPalette  palette( const QWidget* = 0 );
	static QDesktopWidget   *desktop();
	static bool	     sendEvent( QObject *, QEvent * );
    static void	     postEvent( QObject *, QEvent * );
    static void      sendPostedEvents( QObject *receiver, int nType );
    static void      removePostedEvents( QObject *receiver );
    
    QStyle     &style() const;
    static bool reverseLayout();
	
	virtual void HandleMessage( os::Message* );
private:
	QApplicationPrivate* d;
};

extern QApplication* qApp;


#endif // QAPPLICATION_H









