#include <stdio.h>

#include <qfontinfo.h>
#include <qfont.h>
#include <gui/font.h>


class QFontInfoInternal
{
public:
	os::Font* m_pcFont;
	uint32 m_nFlags;
};

QFontInfo::QFontInfo( const QFont& cFont )
{
    d = new QFontInfoInternal;
    d->m_pcFont = cFont.GetFont();
    d->m_nFlags = cFont.GetFontFlags();
    d->m_pcFont->AddRef();
}

QFontInfo::~QFontInfo()
{
    d->m_pcFont->Release();
    delete d;
}

int QFontInfo::pointSize() const
{
    return( (int)d->m_pcFont->GetSize() );
}

bool QFontInfo::fixedPitch() const
{
    return( d->m_nFlags & os::FONT_IS_FIXED );
}



