#ifndef __F_ALISTBOX_H__
#define __F_ALISTBOX_H__

#include <qwidget.h>

#include <gui/listview.h>

class QListBox;


class QListBoxItem : public QObject, public os::ListViewStringRow
{
    Q_OBJECT
public:
    QListBoxItem() { m_pcBox = NULL;/*m_bSelectable = true;*/ }

    void setSelectable( bool bSelectable ) { SetIsSelectable( bSelectable ); }
	
	int width( QListBox* box ) { return( 100 ); }
	int height( QListBox* box ) { return( 100 ); }
	
	QListBox* listBox() const;
	QListBoxItem* next() const;
	
private:
	friend class QListBox;
	QListBox* m_pcBox;
    class Private;
    Private* d;
//    bool m_bSelectable;
};

class QListBoxText : public QListBoxItem
{
public:
    QListBoxText( const QString& cString );
};

class QListBox  : public QWidget
{
    Q_OBJECT
public:
	enum SelectionMode { Single, Multi, Extended, NoSelection };
    QListBox( QWidget* pcParent, const char *name = 0 );
    ~QListBox();
    virtual void HandleMessage( os::Message* pcMessage );
    
    uint count() const;

    void clear();

    void insertItem( const QString &text, int index=-1 );
    void insertItem( const QListBoxItem *, int index=-1 );
    
    QListBoxItem *item( int index ) const;
    QListBoxItem* firstItem();

    virtual void setSelectionMode( SelectionMode );
    void setSelected( int, bool );
    virtual void setCurrentItem( int index );
    bool isSelected( int ) const;

    int index( const QListBoxItem * ) const;
    virtual QSize sizeHint() const;
signals:
    void pressed(QListBoxItem*);
/*
signals:
    void activated( int );
    */  
private:
    class Private;
    Private* d;
};

#endif // __F_ALISTBOX_H__



