

#include <qradiobutton.h>

#include <gui/radiobutton.h>
#include <util/message.h>

enum { ID_SELECTED };

class QRadioButtonWidget : public os::RadioButton
{
public:
	QRadioButtonWidget( os::Rect cFrame, os::String zName, os::String zLabel, os::Message* pcMsg, uint32 nResizeFlags )
		: os::RadioButton( cFrame, zName, zLabel, pcMsg, nResizeFlags )
	{
	}
	virtual void  MouseMove( const os::Point& cNewPos, int nCode, uint32 nButtons, os::Message* pcData )
	{
		//os::RadioButton::MouseMove( cNewPos, nCode, nButtons, pcData );
		os::View::MouseMove( cNewPos, nCode, nButtons, pcData );
	}
    virtual void  MouseDown( const os::Point& cPosition, uint32 nButtons )
    {
    	//os::RadioButton::MouseDown( cPosition, nButtons );
    	os::View::MouseDown( cPosition, nButtons );    	
    }
    virtual void  MouseUp( const os::Point& cPosition, uint32 nButtons, os::Message* pcData )
    {
    	//os::RadioButton::MouseUp( cPosition, nButtons, pcData );
    	os::View::MouseUp( cPosition, nButtons, pcData );
    }
    #if 0
    void Dump( os::View* pcView, int level )
    {
    	os::Rect cRect = pcView->GetFrame();
    	printf( "%i %s %f %f %f %f\n", level, pcView->GetName().c_str(), cRect.left, cRect.top, cRect.right, cRect.bottom );
    	int i;
    	for( i = 0; pcView->GetChildAt( i ) != NULL; i++ )
    	{
    		Dump( pcView->GetChildAt( i ), level + 1 );
    	}
    }
    #endif
};

class QRadioButton::Private
{
public:
    os::RadioButton* m_pcRadioButton;    
};

QRadioButton::QRadioButton( QWidget* pcParent, const char* pzName ) : QWidget( pcParent, pzName )
{
    d = new Private;

    d->m_pcRadioButton = new QRadioButtonWidget( GetBounds(), "radiobutton", "", new os::Message( ID_SELECTED ), os::CF_FOLLOW_ALL );

    AddChild( d->m_pcRadioButton );
    d->m_pcRadioButton->SetTarget( this );
}

QRadioButton::~QRadioButton()
{
    delete d;
}

bool QRadioButton::isChecked() const
{
    return( d->m_pcRadioButton->GetValue() );
}

void QRadioButton::setChecked( bool check )
{ 
    d->m_pcRadioButton->SetValue( check, false );
    emit toggled( check );
}

QSize QRadioButton::sizeHint() const
{
    os::Point cSize = d->m_pcRadioButton->GetPreferredSize( false );
    return( QSize( int(cSize.x), int(cSize.y) ) ); // Sees like KHTML doesn't set the size exactly enough
}

void QRadioButton::HandleMessage( os::Message* pcMessage )
{
    switch( pcMessage->GetCode() )
    {

	case ID_SELECTED:
	{
	    emit clicked();
	    emit toggled( true );
	    break;
	}
	   
	default:
	    QWidget::HandleMessage( pcMessage );
	    break;
    }
}

#include "qradiobutton.moc"





















