#ifndef _QREGION_H_
#define _QREGION_H_

#include "qrect.h"
#include <qpointarray.h>



class QRegion
{
public:
    enum RegionType { Rectangle, Ellipse   };

    QRegion();
    QRegion( int x, int y, int w, int h, RegionType = Rectangle );
//    QRegion( const QRect &, RegionType = Rectangle );
    QRegion( const QPointArray &, bool winding=FALSE );
    QRegion( const QRegion & );
//    QRegion( const QBitmap & );
   ~QRegion();
    QRegion &operator=( const QRegion & );

	QRegion intersect( const QRegion &) const;
	QRegion unite( const QRect &) const;
    bool    contains( const QPoint &p ) const;
    
    void    translate( int dx, int dy );
    QRect   boundingRect() const;
    bool	isNull();
private:
    class Private;
    Private* d;
};

#endif






