#ifndef _QVARIANT_H_
#define _QVARIANT_H_

#include <qstring.h>
#include <qstringlist.h>

class QVariant
{
public:
    enum Type {
	Invalid,
	Map,
	List,
	String,
	StringList,
	Font,
	Pixmap,
	Brush,
	Rect,
	Size,
	Color,
	Palette,
	ColorGroup,
	IconSet,
	Point,
	Image,
	Int,
	UInt,
	Bool,
	Double,
	CString,
	PointArray,
	Region,
	Bitmap,
	Cursor,
	SizePolicy
    };

    QVariant();
    QVariant( int nValue );
    QVariant( const QString& cValue );
    QVariant( bool bValue, int dumy );
    QVariant( double vValue );
    QVariant( const QVariant& );
    ~QVariant();
    QVariant &operator=( const QVariant & );
    
    bool isValid() const;

    Type type() const;
    bool toBool() const;
    bool& asBool() const;
    int toInt() const;
    int& asInt() const;
    uint toUInt() const;
    QString toString() const;
    QString& asString() const;
    QStringList toStringList() const;
private:
    class Private;
    Private* d;
    
};
#endif









