#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>

#include <gui/window.h>
#include <gui/view.h>


#include <string>
#include <list>
#include <vector>

#include <util/message.h>
#include <util/messenger.h>
#include "messages.h"

#ifndef _HTMLVIEW_H_
#define _HTMLVIEW_H_

class KHTMLPart;



// ### from ecma/kjs_proxy.cpp and khtml_factory.cpp
extern "C"
{
    KJSProxy *kjs_html_init( KHTMLPart * );
    void *init_libkhtml();
}


class HTMLPart;

namespace os

{

// ### from khtml_part.cpp
//extern int kjs_lib_count;


struct HistoryEntry
{
    os::Message m_cState;
    KURL m_cURL;
};


class HTMLView : public os::View
{
public:
	HTMLView( const Rect& cFrame, const String& cTitle,
	  uint32 nResizeMask = CF_FOLLOW_LEFT | CF_FOLLOW_TOP,
	  uint32 nFlags = WID_WILL_DRAW | WID_CLEAR_BACKGROUND );
	~HTMLView();
	virtual void KeyDown( const char* pzString, const char* pzRawString, uint32 nQualifiers );
	KHTMLPart* GetPart();
	
	void SetHistoryPosition(int nPos);
	int GetHistoryPosition();
	HistoryEntry* GetCurrentHistory();
	std::vector<HistoryEntry*> GetHistoryEntries();
	os::String GetCurrentURL();
	void OpenURL( const os::String cURL, const KParts::URLArgs& cArgs);
	void AddHistoryEntry();
	bool GoHistory( int nStep );
	void UpdateHistory();
private:
	void SetPart( HTMLPart *pcPart );
	class Private;
	Private* m;
	
};



}

#endif
