#include "addresspanel.h"
#include <util/message.h>

using namespace os;

AddressPanel::AddressPanel(os::Messenger* pcTarget,int nCode) : DropdownMenu(Rect(),"address_panel",CF_FOLLOW_LEFT | CF_FOLLOW_RIGHT | CF_FOLLOW_TOP)
{
	m_pcTarget = pcTarget;
	m_nCode = nCode;
	m_cPreferredSize = os::Point(0,0);
}


void AddressPanel::KeyUp( const char* pzString, const char* pzRawString, uint32 nQualifiers )
{
	if (pzString[0] == VK_ENTER)
	{
		os::Message cMsg(m_nCode);
		cMsg.AddInt32("events",os::TextView::EI_ENTER_PRESSED);
		m_pcTarget->SendMessage(&cMsg);
	}
	
	if (pzString[0] == VK_ESCAPE)
	{
		os::Message cMsg(m_nCode);
		cMsg.AddInt32("events",os::TextView::EI_ESC_PRESSED);
		m_pcTarget->SendMessage(&cMsg);
	}	
}

void AddressPanel::MouseUp( const Point& cPosition, uint32 nButtons, Message* pcData )
{
}

void AddressPanel::SelectAll()
{
	GetTextView()->SelectAll();
}

void AddressPanel::Delete(bool bSendNotify)
{
	 GetTextView()->Delete( bSendNotify);
}


void AddressPanel::Paste(bool bSendNotify)
{
	GetTextView()->Paste(bSendNotify);
}

void AddressPanel::SetPreferredSize(os::Point cSize)
{
	m_cPreferredSize = cSize;
}

os::Point AddressPanel::GetPreferredSize(bool bFlag) const
{
	return m_cPreferredSize;
}

