/*  Syllable Dock
 *  Copyright (C) 2003 Arno Klenke
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of version 2 of the GNU Library
 *  General Public License as published by the Free Software
 *  Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA
 */
 
#ifndef _BOOKMARKS_TOOLBAR_H
#define _BOOKMARKS_TOOLBAR_H

#include <gui/toolbar.h>
#include <gui/menu.h>
#include <gui/imagebutton.h>
#include <storage/path.h>
#include <storage/nodemonitor.h>
#include <queue>
#include <algorithm>

using std::queue;
using std::make_pair;
using std::pair;

class BookmarksToolBar : public os::ToolBar
{
public:
	BookmarksToolBar( os::Handler* pcTarget, os::Path cPath, os::Rect cFrame, const char* pzName, int32 nResizeMask );
	~BookmarksToolBar();
	
	void Reload();
	void SortItems();

private:
	os::Handler* m_pcHandler;
	os::NodeMonitor* m_pcMonitor;
	os::Path m_cPath;
	
	os::Menu* m_pcContextMenu;
	
	os::Image* m_pcDirIcon;
	os::Menu*  m_pcOtherMenu;
	
	queue< std::pair<os::Menu*, os::Image*> > m_pcDirItems;
	
};

#endif








