#ifndef FIND_PANEL_H
#define FIND_PANEL_H

#include <gui/stringview.h>
#include <gui/textview.h>
#include <gui/checkbox.h>
#include <gui/button.h>
#include <gui/imagebutton.h>
#include <gui/layoutview.h>
#include <util/message.h>

using namespace os;

class FindPanel : public os::LayoutView
{
public:
	FindPanel(const os::String& cName, os::Messenger* pcTarget=NULL,const os::String& cText="",uint32 nFlags=FIND_LAYOUT);
	
	enum e_find_layout
	{
		FIND_LAYOUT,
		FIND_AND_REPLACE_LAYOUT,
	};
	
	enum messages
	{
		FIND_NEXT=0x6f2,
		FIND_PREV,
		REPLACE,
		REPLACE_ALL,
		MATCH_CASE,
		CLOSE,
	};
	
	void HandleMessage(Message*);
	void AllAttached();
	os::Point GetPreferredSize(bool) const;
	void SetTabs();
	
	void SetText(const os::String& cText);
	os::String GetText() const;
	
	void Focus();
	
private:
	void _Layout();
	
	class Private;
	Private* m;
};

#endif














