#include "settings.h"
#include "utils.h"

#include <util/settings.h>
#include <gui/desktop.h>
#include <gui/rect.h>

using namespace os;

ABrowse_Settings::ABrowse_Settings()
{
}

bool ABrowse_Settings::LoadSettings()
{
	bool bReturn = m_bLoadWorked = true;
	os::Settings* pcSettings = new os::Settings();

	if (pcSettings->Load()==0)
	{
		if (pcSettings->FindRect("frame",&m_cFrame) != 0)	
			m_bLoadWorked = false;

		
		if (pcSettings->FindString("file/path",&m_cDefaultPath) != 0)
			m_bLoadWorked = false;

		if (pcSettings->FindBool("open_source_in_editor",&m_bOpenSourceInEditor) != 0)
			m_bOpenSourceInEditor = false;
		
		if (pcSettings->FindString("source_editor",&m_cEditor) != 0)
			m_cEditor = "/Applications/AEdit/AEdit";
	}
	else
	{
		bReturn = false;
	}
	delete( pcSettings );
	return bReturn;
}

void ABrowse_Settings::SaveSettings()
{
	os::Settings * pcSettings = new os::Settings();
	pcSettings->AddRect( "frame", m_cFrame );
	pcSettings->AddString("file/path",m_cDefaultPath);
	pcSettings->AddString("source_editor",m_cEditor);
	pcSettings->AddBool("open_source_in_editor",m_bOpenSourceInEditor);
	pcSettings->Save();
	delete( pcSettings );
}
