#ifndef SETTINGS_H
#define SETTINGS_H

#include <gui/rect.h>
#include <util/string.h>

class ABrowse_Settings
{
public:
	ABrowse_Settings();

	bool LoadSettings();
	bool LoadFinished(){return m_bLoadWorked;}

	void SaveSettings();

	
	os::Rect GetFrame() { return m_cFrame; }
	void SetFrame(os::Rect cFrame) { m_cFrame = cFrame;}
	
	os::String GetDefaultPath() { return m_cDefaultPath; }
	void SetDefaultPath(os::String cPath){m_cDefaultPath = cPath;}

	bool GetOpenSourceInEditorOption() { return m_bOpenSourceInEditor;}
	void SetOpenSourceInEditorOption(bool bSource) { m_bOpenSourceInEditor = bSource;}

	os::String GetSourceEditor() { return m_cEditor;}
	void SetSourceEditor(os::String cEditor) {m_cEditor = cEditor;}

private:
	os::Rect m_cFrame;
	os::String m_cDefaultPath;

	//default editor
	bool m_bOpenSourceInEditor;
	os::String m_cEditor;

	bool m_bLoadWorked;
};

#endif
