#ifndef _SETTINGS_DIALOG_H
#define _SETTINGS_DIALOG_H

#include <gui/layoutview.h>
#include <gui/iconview.h>
#include <gui/dropdownmenu.h>
#include <gui/textview.h>
#include <gui/stringview.h>
#include <gui/button.h>
#include <gui/window.h>
#include <gui/view.h>
#include <gui/image.h>
#include <util/string.h>
#include <algorithm>
#include <list>
#include <util/messenger.h>

#include "settingsnode.h"
#include "settings.h"

using namespace os;

class SettingsIconView;

class SettingsDialog : public os::Window
{
	public:
		SettingsDialog(os::Messenger* pcTarget,ABrowse_Settings*);

		virtual bool OkToQuit( void );
		virtual void HandleMessage( os::Message* pcMessage );
		void SetTabs();
	private:
		os::LayoutView*		m_pcView, *pcSettingsView;
		os::HLayoutNode*	m_pcHLayout;
		
		
		SettingsIconView*	m_pcIconView;
		
		os::Button*			m_pcOk;
		os::Button*			m_pcCancel;
		
		os::Messenger*		m_pcTarget;
		ABrowse_Settings*	m_pcSettings;
		
		std::vector<SettingsNode*> m_cSettingNodes;
};

#endif













